[FTBFS] perl fails on arm with -O2

Bug #23789 reported by Debian Bug Importer on 2005-10-12
4
Affects Status Importance Assigned to Milestone
perl (Debian)
Fix Released
Unknown
perl (Ubuntu)
High
Unassigned

Bug Description

Automatically imported from Debian bug report #333510 http://bugs.debian.org/333510

Revision history for this message
Debian Bug Importer (debzilla) wrote :

Automatically imported from Debian bug report #333510 http://bugs.debian.org/333510

Revision history for this message
Debian Bug Importer (debzilla) wrote :

Message-ID: <email address hidden>
Date: Wed, 12 Oct 2005 12:01:03 +0300
From: Riku Voipio <email address hidden>
To: Debian Bug Tracking System <email address hidden>
Subject: [FTBFS] perl fails on arm with -O2

--45Z9DzgjV8m4Oswq
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline

Package: perl
Version: 5.8.7-5
Severity: serious
Justification: no longer builds from source

Perl fails to build on arm/armeb with -O2 optimization and current gcc4.
with -01, perl compiled fine and pass testsuites withoout a problem. By
using the following patch instead of the current 63_debian_ppc_opt..
patch, this (gcc) issue can be worked around.

-- System Information:
Debian Release: testing/unstable
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: arm (armv4l)
Shell: /bin/sh linked to /bin/bash
Kernel: Linux 2.6.13
Locale: LANG=C, LC_CTYPE=C (charmap=ANSI_X3.4-1968)

Versions of packages perl depends on:
ii libc6 2.3.5-6 GNU C Library: Shared libraries an
ii libdb4.2 4.2.52-19 Berkeley v4.2 Database Libraries [
ii libgdbm3 1.8.3-2 GNU dbm database routines (runtime
ii perl-base 5.8.7-3 The Pathologically Eclectic Rubbis
ii perl-modules 5.8.7-5 Core Perl modules

Versions of packages perl recommends:
pn perl-doc <none> (no description available)

-- no debconf information

--45Z9DzgjV8m4Oswq
Content-Type: text/plain; charset=us-ascii
Content-Disposition: attachment; filename=63_debian_arm_optim

Don't need to downgrade optimisation on ppc with gcc 4.0

diff -Naur --exclude=debian perl-5.8.7.orig/hints/linux.sh perl-5.8.7/hints/linux.sh
--- perl-5.8.7.orig/hints/linux.sh 2005-04-05 06:08:31.000000000 +1000
+++ perl-5.8.7/hints/linux.sh 2005-10-11 11:00:00.000000000 +0000
@@ -90,7 +90,7 @@
 '')
     optimize='-O2'
     case "`uname -m`" in
- ppc*)
+ arm*)
             # on ppc, it seems that gcc (at least gcc 3.3.2) isn't happy
      # with -O2 ; so downgrade to -O1.
             optimize='-O1'

--45Z9DzgjV8m4Oswq--

Revision history for this message
Matt Zimmerman (mdz) wrote :

arm-specific

Revision history for this message
In , Brendan O'Dea (bod) wrote : Re: Bug#333510: [FTBFS] perl fails on arm with -O2

On Wed, Oct 12, 2005 at 12:01:03PM +0300, Riku Voipio wrote:
>Perl fails to build on arm/armeb with -O2 optimization and current gcc4.
>with -01, perl compiled fine and pass testsuites withoout a problem. By
>using the following patch instead of the current 63_debian_ppc_opt..
>patch, this (gcc) issue can be worked around.

Building a new package now. I've dropped the optimisation on only the
following files (which proved to be the source of the problem on other
architectures): pp_ctl.c, pp_hot.c and pp_sort.c .

If this doesn't fix the problem, re-open and I'll drop everything to
-O1.

Would have tested this first, but unfortunately there doesn't seem to be
an arm machine available for developers right now...

--bod

Revision history for this message
Debian Bug Importer (debzilla) wrote :

Message-ID: <email address hidden>
Date: Thu, 13 Oct 2005 13:49:45 +1000
From: Brendan O'Dea <email address hidden>
To: Riku Voipio <email address hidden>, <email address hidden>
Subject: Re: Bug#333510: [FTBFS] perl fails on arm with -O2

On Wed, Oct 12, 2005 at 12:01:03PM +0300, Riku Voipio wrote:
>Perl fails to build on arm/armeb with -O2 optimization and current gcc4.
>with -01, perl compiled fine and pass testsuites withoout a problem. By
>using the following patch instead of the current 63_debian_ppc_opt..
>patch, this (gcc) issue can be worked around.

Building a new package now. I've dropped the optimisation on only the
following files (which proved to be the source of the problem on other
architectures): pp_ctl.c, pp_hot.c and pp_sort.c .

If this doesn't fix the problem, re-open and I'll drop everything to
-O1.

Would have tested this first, but unfortunately there doesn't seem to be
an arm machine available for developers right now...

--bod

Revision history for this message
In , Brendan O'Dea (bod) wrote : Bug#333510: fixed in perl 5.8.7-6
Download full text (3.6 KiB)

Source: perl
Source-Version: 5.8.7-6

We believe that the bug you reported is fixed in the latest version of
perl, which is due to be installed in the Debian FTP archive:

libcgi-fast-perl_5.8.7-6_all.deb
  to pool/main/p/perl/libcgi-fast-perl_5.8.7-6_all.deb
libperl-dev_5.8.7-6_sparc.deb
  to pool/main/p/perl/libperl-dev_5.8.7-6_sparc.deb
libperl5.8_5.8.7-6_sparc.deb
  to pool/main/p/perl/libperl5.8_5.8.7-6_sparc.deb
perl-base_5.8.7-6_sparc.deb
  to pool/main/p/perl/perl-base_5.8.7-6_sparc.deb
perl-debug_5.8.7-6_sparc.deb
  to pool/main/p/perl/perl-debug_5.8.7-6_sparc.deb
perl-doc_5.8.7-6_all.deb
  to pool/main/p/perl/perl-doc_5.8.7-6_all.deb
perl-modules_5.8.7-6_all.deb
  to pool/main/p/perl/perl-modules_5.8.7-6_all.deb
perl-suid_5.8.7-6_sparc.deb
  to pool/main/p/perl/perl-suid_5.8.7-6_sparc.deb
perl_5.8.7-6.diff.gz
  to pool/main/p/perl/perl_5.8.7-6.diff.gz
perl_5.8.7-6.dsc
  to pool/main/p/perl/perl_5.8.7-6.dsc
perl_5.8.7-6_sparc.deb
  to pool/main/p/perl/perl_5.8.7-6_sparc.deb

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed. If you
have further comments please address them to <email address hidden>,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Brendan O'Dea <email address hidden> (supplier of updated perl package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing <email address hidden>)

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Thu, 13 Oct 2005 13:35:38 +1000
Source: perl
Binary: perl-base libcgi-fast-perl libperl-dev perl-debug perl-modules perl libperl5.8 perl-suid perl-doc
Architecture: source sparc all
Version: 5.8.7-6
Distribution: unstable
Urgency: low
Maintainer: Brendan O'Dea <email address hidden>
Changed-By: Brendan O'Dea <email address hidden>
Description:
 libcgi-fast-perl - CGI::Fast Perl module
 libperl-dev - Perl library: development files
 libperl5.8 - Shared Perl library
 perl - Larry Wall's Practical Extraction and Report Language
 perl-base - The Pathologically Eclectic Rubbish Lister
 perl-debug - Debug-enabled Perl interpreter
 perl-doc - Perl documentation
 perl-modules - Core Perl modules
 perl-suid - Runs setuid Perl scripts
Closes: 333510
Changes:
 perl (5.8.7-6) unstable; urgency=low
 .
   * Downgrade optimisation on arm to -O1 for certain files due to
     problems with gcc 4.0 (closes: #333510).
Files:
 07ed9eee9be72e84cbc929a464ddf6be 717 perl standard perl_5.8.7-6.dsc
 edc4a45010a516673a83cc63cfa5e20b 132056 perl standard perl_5.8.7-6.diff.gz
 b0788c6e032f6ec21812c3603d6651aa 38888 perl optional libcgi-fast-perl_5.8.7-6_all.deb
 297cda58b630ed35a51c1657bb268a63 7208092 doc optional perl-doc_5.8.7-6_all.deb
 b0988f40ecfb20377b1e2230f0594c13 2325798 perl standard perl-modules_5.8.7-6_all.deb
 7ef90432c90bf7e4a0bc77fa627685d8 791980 base required perl-base_5.8.7-6_sparc.deb
 39f6c54e820a123dcd329f61809d74ec 2536464 perl optional perl-debug_5.8.7-6_sparc.deb
 f11c4342f61892808306ca2bc111fb18 30032 perl optional perl-suid_5.8.7-6_...

Read more...

Revision history for this message
Debian Bug Importer (debzilla) wrote :
Download full text (3.8 KiB)

Message-Id: <email address hidden>
Date: Wed, 12 Oct 2005 22:47:12 -0700
From: Brendan O'Dea <email address hidden>
To: <email address hidden>
Subject: Bug#333510: fixed in perl 5.8.7-6

Source: perl
Source-Version: 5.8.7-6

We believe that the bug you reported is fixed in the latest version of
perl, which is due to be installed in the Debian FTP archive:

libcgi-fast-perl_5.8.7-6_all.deb
  to pool/main/p/perl/libcgi-fast-perl_5.8.7-6_all.deb
libperl-dev_5.8.7-6_sparc.deb
  to pool/main/p/perl/libperl-dev_5.8.7-6_sparc.deb
libperl5.8_5.8.7-6_sparc.deb
  to pool/main/p/perl/libperl5.8_5.8.7-6_sparc.deb
perl-base_5.8.7-6_sparc.deb
  to pool/main/p/perl/perl-base_5.8.7-6_sparc.deb
perl-debug_5.8.7-6_sparc.deb
  to pool/main/p/perl/perl-debug_5.8.7-6_sparc.deb
perl-doc_5.8.7-6_all.deb
  to pool/main/p/perl/perl-doc_5.8.7-6_all.deb
perl-modules_5.8.7-6_all.deb
  to pool/main/p/perl/perl-modules_5.8.7-6_all.deb
perl-suid_5.8.7-6_sparc.deb
  to pool/main/p/perl/perl-suid_5.8.7-6_sparc.deb
perl_5.8.7-6.diff.gz
  to pool/main/p/perl/perl_5.8.7-6.diff.gz
perl_5.8.7-6.dsc
  to pool/main/p/perl/perl_5.8.7-6.dsc
perl_5.8.7-6_sparc.deb
  to pool/main/p/perl/perl_5.8.7-6_sparc.deb

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed. If you
have further comments please address them to <email address hidden>,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Brendan O'Dea <email address hidden> (supplier of updated perl package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing <email address hidden>)

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Thu, 13 Oct 2005 13:35:38 +1000
Source: perl
Binary: perl-base libcgi-fast-perl libperl-dev perl-debug perl-modules perl libperl5.8 perl-suid perl-doc
Architecture: source sparc all
Version: 5.8.7-6
Distribution: unstable
Urgency: low
Maintainer: Brendan O'Dea <email address hidden>
Changed-By: Brendan O'Dea <email address hidden>
Description:
 libcgi-fast-perl - CGI::Fast Perl module
 libperl-dev - Perl library: development files
 libperl5.8 - Shared Perl library
 perl - Larry Wall's Practical Extraction and Report Language
 perl-base - The Pathologically Eclectic Rubbish Lister
 perl-debug - Debug-enabled Perl interpreter
 perl-doc - Perl documentation
 perl-modules - Core Perl modules
 perl-suid - Runs setuid Perl scripts
Closes: 333510
Changes:
 perl (5.8.7-6) unstable; urgency=low
 .
   * Downgrade optimisation on arm to -O1 for certain files due to
     problems with gcc 4.0 (closes: #333510).
Files:
 07ed9eee9be72e84cbc929a464ddf6be 717 perl standard perl_5.8.7-6.dsc
 edc4a45010a516673a83cc63cfa5e20b 132056 perl standard perl_5.8.7-6.diff.gz
 b0788c6e032f6ec21812c3603d6651aa 38888 perl optional libcgi-fast-perl_5.8.7-6_all.deb
 297cda58b630ed35a51c1657bb268a63 7208092 doc optional perl-doc_5.8.7-6_all.deb
 b0988f40ecfb20377b1e2230f0594c13 2325798 perl standard perl-modules_5.8.7-6_all.deb
 7ef90432c90bf7e4a0bc77fa627685d8 79198...

Read more...

Revision history for this message
In , Brendan O'Dea (bod-c47) wrote : Re: Bug#333510: [FTBFS] perl fails on arm with -O2

reopen 333510
thanks

On Thu, Oct 13, 2005 at 01:49:45PM +1000, Brendan O'Dea wrote:
>Building a new package now. I've dropped the optimisation on only the
>following files (which proved to be the source of the problem on other
>architectures): pp_ctl.c, pp_hot.c and pp_sort.c .
>
>If this doesn't fix the problem, re-open and I'll drop everything to
>-O1.

Drats. That didn't work.

While I can simplly drop the optimisation level entirely, I've been able
in the past to do so only on specific problem code (which is my
preference).

A login to an unstable arm box would help a lot (hence the CC to Vince).

--bod

Revision history for this message
Debian Bug Importer (debzilla) wrote :

Message-ID: <email address hidden>
Date: Thu, 13 Oct 2005 23:41:10 +1000
From: Brendan O'Dea <email address hidden>
To: Riku Voipio <email address hidden>, <email address hidden>
Cc: <email address hidden>
Subject: Re: Bug#333510: [FTBFS] perl fails on arm with -O2

reopen 333510
thanks

On Thu, Oct 13, 2005 at 01:49:45PM +1000, Brendan O'Dea wrote:
>Building a new package now. I've dropped the optimisation on only the
>following files (which proved to be the source of the problem on other
>architectures): pp_ctl.c, pp_hot.c and pp_sort.c .
>
>If this doesn't fix the problem, re-open and I'll drop everything to
>-O1.

Drats. That didn't work.

While I can simplly drop the optimisation level entirely, I've been able
in the past to do so only on specific problem code (which is my
preference).

A login to an unstable arm box would help a lot (hence the CC to Vince).

--bod

Revision history for this message
In , Brendan O'Dea (bod) wrote : Bug#333510: fixed in perl 5.8.7-7
Download full text (3.7 KiB)

Source: perl
Source-Version: 5.8.7-7

We believe that the bug you reported is fixed in the latest version of
perl, which is due to be installed in the Debian FTP archive:

libcgi-fast-perl_5.8.7-7_all.deb
  to pool/main/p/perl/libcgi-fast-perl_5.8.7-7_all.deb
libperl-dev_5.8.7-7_sparc.deb
  to pool/main/p/perl/libperl-dev_5.8.7-7_sparc.deb
libperl5.8_5.8.7-7_sparc.deb
  to pool/main/p/perl/libperl5.8_5.8.7-7_sparc.deb
perl-base_5.8.7-7_sparc.deb
  to pool/main/p/perl/perl-base_5.8.7-7_sparc.deb
perl-debug_5.8.7-7_sparc.deb
  to pool/main/p/perl/perl-debug_5.8.7-7_sparc.deb
perl-doc_5.8.7-7_all.deb
  to pool/main/p/perl/perl-doc_5.8.7-7_all.deb
perl-modules_5.8.7-7_all.deb
  to pool/main/p/perl/perl-modules_5.8.7-7_all.deb
perl-suid_5.8.7-7_sparc.deb
  to pool/main/p/perl/perl-suid_5.8.7-7_sparc.deb
perl_5.8.7-7.diff.gz
  to pool/main/p/perl/perl_5.8.7-7.diff.gz
perl_5.8.7-7.dsc
  to pool/main/p/perl/perl_5.8.7-7.dsc
perl_5.8.7-7_sparc.deb
  to pool/main/p/perl/perl_5.8.7-7_sparc.deb

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed. If you
have further comments please address them to <email address hidden>,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Brendan O'Dea <email address hidden> (supplier of updated perl package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing <email address hidden>)

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Mon, 17 Oct 2005 23:16:32 +1000
Source: perl
Binary: perl-base libcgi-fast-perl libperl-dev perl-debug perl-modules perl libperl5.8 perl-suid perl-doc
Architecture: source sparc all
Version: 5.8.7-7
Distribution: unstable
Urgency: low
Maintainer: Brendan O'Dea <email address hidden>
Changed-By: Brendan O'Dea <email address hidden>
Description:
 libcgi-fast-perl - CGI::Fast Perl module
 libperl-dev - Perl library: development files
 libperl5.8 - Shared Perl library
 perl - Larry Wall's Practical Extraction and Report Language
 perl-base - The Pathologically Eclectic Rubbish Lister
 perl-debug - Debug-enabled Perl interpreter
 perl-doc - Perl documentation
 perl-modules - Core Perl modules
 perl-suid - Runs setuid Perl scripts
Closes: 333510
Changes:
 perl (5.8.7-7) unstable; urgency=low
 .
   * ARM optimisation fix take 2. Downgrade optimisation of pp_pack to
     -Os (closes: #333510). Thanks to Bill Gatliff for the extended
     use of the CSB625 is his basement.
 .
   * Change section of perl-base to "perl".
Files:
 5652b6336c8957bafc0a3637307baf04 717 perl standard perl_5.8.7-7.dsc
 980ddadb9cb3f50128c995e83394c7de 132124 perl standard perl_5.8.7-7.diff.gz
 a0a6fc978d6b00b1ca071e35af7c5b8d 38984 perl optional libcgi-fast-perl_5.8.7-7_all.deb
 9a24100843e215e33d57b49c03a522c6 7208090 doc optional perl-doc_5.8.7-7_all.deb
 65b185ff871ad95db0089b476227b920 2325782 perl standard perl-modules_5.8.7-7_all.deb
 d8e9d01bf4e4e4be9d386ce921e96764 792120 perl required perl-base_5.8.7-7_sparc.deb
 3eb86b60d59cfa99d9b42d56140b560f 2536452...

Read more...

Revision history for this message
Debian Bug Importer (debzilla) wrote :
Download full text (3.9 KiB)

Message-Id: <email address hidden>
Date: Mon, 17 Oct 2005 08:47:10 -0700
From: Brendan O'Dea <email address hidden>
To: <email address hidden>
Subject: Bug#333510: fixed in perl 5.8.7-7

Source: perl
Source-Version: 5.8.7-7

We believe that the bug you reported is fixed in the latest version of
perl, which is due to be installed in the Debian FTP archive:

libcgi-fast-perl_5.8.7-7_all.deb
  to pool/main/p/perl/libcgi-fast-perl_5.8.7-7_all.deb
libperl-dev_5.8.7-7_sparc.deb
  to pool/main/p/perl/libperl-dev_5.8.7-7_sparc.deb
libperl5.8_5.8.7-7_sparc.deb
  to pool/main/p/perl/libperl5.8_5.8.7-7_sparc.deb
perl-base_5.8.7-7_sparc.deb
  to pool/main/p/perl/perl-base_5.8.7-7_sparc.deb
perl-debug_5.8.7-7_sparc.deb
  to pool/main/p/perl/perl-debug_5.8.7-7_sparc.deb
perl-doc_5.8.7-7_all.deb
  to pool/main/p/perl/perl-doc_5.8.7-7_all.deb
perl-modules_5.8.7-7_all.deb
  to pool/main/p/perl/perl-modules_5.8.7-7_all.deb
perl-suid_5.8.7-7_sparc.deb
  to pool/main/p/perl/perl-suid_5.8.7-7_sparc.deb
perl_5.8.7-7.diff.gz
  to pool/main/p/perl/perl_5.8.7-7.diff.gz
perl_5.8.7-7.dsc
  to pool/main/p/perl/perl_5.8.7-7.dsc
perl_5.8.7-7_sparc.deb
  to pool/main/p/perl/perl_5.8.7-7_sparc.deb

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed. If you
have further comments please address them to <email address hidden>,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Brendan O'Dea <email address hidden> (supplier of updated perl package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing <email address hidden>)

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Mon, 17 Oct 2005 23:16:32 +1000
Source: perl
Binary: perl-base libcgi-fast-perl libperl-dev perl-debug perl-modules perl libperl5.8 perl-suid perl-doc
Architecture: source sparc all
Version: 5.8.7-7
Distribution: unstable
Urgency: low
Maintainer: Brendan O'Dea <email address hidden>
Changed-By: Brendan O'Dea <email address hidden>
Description:
 libcgi-fast-perl - CGI::Fast Perl module
 libperl-dev - Perl library: development files
 libperl5.8 - Shared Perl library
 perl - Larry Wall's Practical Extraction and Report Language
 perl-base - The Pathologically Eclectic Rubbish Lister
 perl-debug - Debug-enabled Perl interpreter
 perl-doc - Perl documentation
 perl-modules - Core Perl modules
 perl-suid - Runs setuid Perl scripts
Closes: 333510
Changes:
 perl (5.8.7-7) unstable; urgency=low
 .
   * ARM optimisation fix take 2. Downgrade optimisation of pp_pack to
     -Os (closes: #333510). Thanks to Bill Gatliff for the extended
     use of the CSB625 is his basement.
 .
   * Change section of perl-base to "perl".
Files:
 5652b6336c8957bafc0a3637307baf04 717 perl standard perl_5.8.7-7.dsc
 980ddadb9cb3f50128c995e83394c7de 132124 perl standard perl_5.8.7-7.diff.gz
 a0a6fc978d6b00b1ca071e35af7c5b8d 38984 perl optional libcgi-fast-perl_5.8.7-7_all.deb
 9a24100843e215e33d57b49c03a522c6 7208090 doc optional perl-doc_5.8.7-7_all.deb
 65b185f...

Read more...

Revision history for this message
In , Lennert Buytenhek (buytenh) wrote : Re: Bug#333510: [FTBFS] perl fails on arm with -O2

Please also enable the workaround for the armeb (big-endian ARM)
arch. The original patch from Riku checked for arm*, which does
include armeb, but the patch that went in checks for arm-*.

Revision history for this message
Debian Bug Importer (debzilla) wrote :

Message-ID: <email address hidden>
Date: Fri, 21 Oct 2005 23:29:29 +0200
From: Lennert Buytenhek <email address hidden>
To: <email address hidden>
Subject: Re: Bug#333510: [FTBFS] perl fails on arm with -O2

Please also enable the workaround for the armeb (big-endian ARM)
arch. The original patch from Riku checked for arm*, which does
include armeb, but the patch that went in checks for arm-*.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.